ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c								                      c
c	labkin.for						                      c
c								                      c
c	This program's purpose is to graphically display expected       c
c	excitation energies of target nuclei.			          c
c							                            c
c	Author: Stephen Graves..............................6/10        c
c	Portions of code taken from relkin by C. Torre......3/82        c
c								                      c
c	Supplementary files: wallet.dat, level_energy.txt	   	    c
c								                      c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


	program labkin

ccccccccccccccccccccccccccccccc
c     VARIABLE DECLARATIONS   c
c     particles:              c
c     1) Target               c
c     2) Incident             c
c     3) Scattered/Detected   c
c     4) Residual             c
ccccccccccccccccccccccccccccccc

	implicit none
      integer ia(20,4),iz(20,4)
      integer i, ct, dt, y(10000), ma
      character again, lblgo
      character*25 reactn
      integer*4 z1,z2,z3,z4,a1,a2,a3,a4,q
      integer*4 neb,ntlab,nex3,nex4,nex2
      real*8 mass(300,200)
      real*8 eb(10000),tlab(10000),ex3(10000),ex4(10000),ex2(10000),
     &dat(10000),ext4(10000)
      logical first
	common/blkst/eb,tlab,ex2,ex3,ex4,z1,z2,z3,z4,a1,a2,a3,a4,
     &      neb,ntlab,nex2,nex3,nex4
      common/masses/mass
      common ct,dt,dat,y

ccccccccccccccccccccccccccccccc
c     INITIALIZATION          c
ccccccccccccccccccccccccccccccc
      again = 'y'
      first = .true.
      ct = 0
      dt = 0
      z1=1
      z2=1
      z3=1
      z4=1
      a1=1
      a2=1
      a3=1
      a4=1
      neb=1
      eb(1)=10.0d0
      ntlab=1
      tlab(1)=10.0d0*3.141592654d0/180.d0
      nex2=1
      ex2(1)=0.0d0
      nex3=1
      ex3(1)=0.0d0
      nex4=1
      ex4(1)=0.0d0
      ma=0

ccccccccccccccccccccccccccccccc
C     CONTROL SECTION         C
ccccccccccccccccccccccccccccccc
      print*,
      do while((again .eq. 'y') .OR. (again .eq. 'Y')) !Ends the program after an input cycle

         if(first) then
            first = .false.
            open(unit=7,file='labkin.agr',status='unknown')
            call initdat
         end if

	   call loadmass        !Reads particle masses from data file

         if(ct.eq.0) then
            call ebeam(neb,eb)
            call theta(ntlab,tlab)
         end if

1        call decifr(ia,iz,1,reactn)
         z1=iz(1,2)
         z2=iz(1,1)
         z3=iz(1,3)
         z4=iz(1,4)
         a1=ia(1,2)
         a2=ia(1,1)
         a3=ia(1,3)
         a4=ia(1,4)

         call loaden(a4,z4,nex4,ex4)
         call loaden(a3,z3,nex3,ex3)
	   call go
         if(ct.eq.0) then
            call lbl(reactn,1,eb(1),tlab(1))
         end if
         if(ct.eq.1) then
            call lbl(reactn,2,eb(1),tlab(1))
         endif
         if(ct.eq.2) then
            call lbl(reactn,3,eb(1),tlab(1))
         endif
         if(ct.eq.3) then
            call lbl(reactn,4,eb(1),tlab(1))
         endif
         ct = ct+1


	   print*, "Do you want to enter another reaction? (y/n)"
21	   read*, again
	   if((again .ne. 'y') .AND. (again .ne. 'Y')
     &   	.AND. (again .ne. 'n') .AND. (again .ne. 'N')) then
	      print*, "Invalid input"
	      goto 21
	   end if

         do i=1,nex4
            ma=ma+1
            ext4(ma)=ex4(i)
         end do

	end do


      print*, "Would you like data labels to be displayed? (y/n)"
22    read*, lblgo
      if((again .ne. 'y') .AND. (again .ne. 'Y')
     &   .AND. (again .ne. 'n') .AND. (again .ne. 'N')) then
         print*, "Invalid input"
         goto 22
      end if
      if((lblgo.eq.'y') .OR. (lblgo.eq.'Y')) then
         do i=1,dt
            call datalbl(dat(i),y(i),ext4(i))
         end do
      end if

      do i=1,dt
         write(7,5) dat(i), ", ", y(i), ", 1, 0"
5        format(f10.4, A2, I1, A6)
      end do
	print*, "Done"
	stop
	end




ccccccccccccccccccccccccccccccc
C     SUBROUTINES             C
ccccccccccccccccccccccccccccccc

      subroutine ebeam(neb,eb)
      implicit none
      integer*4 neb,n,ios
      real*8 eb(10000)

4     continue
      print*, "Input beam energy:"
c7     write(6,1)
c      read(5,*,IOSTAT=ios)n
      n=1
c      if(((n.lt.0 .or. n.gt.100).and. n.ne.999).or. ios.ne.0) goto 7

      if(n.ne.0) then
        neb=n
        call ins(neb,eb)
      endif

      if(eb(1).le.0.0) then
         print*, "Invalid Energy"
         goto 4
      end if

      return
c1     format(' input the number of beam energies to be entered')
      end

      subroutine ins(n,x)
      implicit none
      integer*4 n
      real*8 x(10000)

      if(n.ge.1 .and. n.le.100) then
        call onebyone(n,x)
      elseif(n.eq.999) then
        call minmax(n,x)
      endif
      return
      end


      subroutine minmax(n,x)
      implicit none
      integer*4 n,ios,i
      real*8    x(10000),min,max,delta

1     write(6,3)
c     write(6,3)
      read(5,*,IOSTAT=ios)min,max,delta
      if(ios.ne.0 .or. delta.le.0. .or. min.ge.max) goto 1
c      if( (max-min)/delta .gt. 99.0 ) goto 1
        n=int((max-min)/delta)+1
        do 2 i=0,n-1
          x(i+1)=(min+delta*(dfloat(i)))
2       continue
3     format(' input min,max,delta')
      return
      end


      subroutine onebyone(n,x)
      implicit none
      integer*4 n,i,ios
      real*8 x(10000)
      do 10 i=1,n
c4       write(6,2)
c     write(6,2)
      read(5,*,IOSTAT=ios)x(i)
c        if(ios.ne.0) goto 4
10    continue
      return
c2     format(' Input a beam energy')
      end



      subroutine theta(ntlab,tlab)
      implicit none
      integer*4 ntlab,n,ios
      real*8 tlab(10000),pi
      pi = dacos(-1.0d+00)
 
c      write(6,1)
c      read(5,*,IOSTAT=ios)n
      n = 1
      print*, "Input angle:"
      if(n.ne.0) then
        ntlab=n
        call ins(ntlab,tlab)
      endif 
      do 2 n = 1,ntlab
        tlab(n) = tlab(n)*pi/180.0
2     continue
      return
c1     format(' Input the number of angles to be entered')
      end



      subroutine loaden(a,z,nex4,ex4)
      implicit none

      integer i,a,z,p,c
      integer*4 nex4
      integer az(155000,2)      ! Stores mass and nucleus information from data file
      real    b(155000)         ! Stores energy levels from data file
      real    en(1000)
      real*8  ex4(10000)
      logical switch

      open(unit=123,file="level_energy.dat",status="unknown") ! Opens Data File

      do i=1,151688
         read(123,*,end=124) az(i,1), az(i,2), b(i)
      end do
124   continue

c      print*, "Mass =   ", a
c      print*, "Atomic #=", z

    ! Finds the first value at the specified mass
      i=1
      switch = .true.
      do while (switch)
         if (a.eq.az(i,1)) then
            switch = .false.
            p = i
         end if
         i = i+1
      end do
    ! Reads each matching energy level into the en(1000) array
      c=0
      do while (a.eq.az(p,1))
         if(az(p,2).eq.z) then
            c=c+1
            en(c) = b(p)/1000
         end if
         p=p+1
      end do
      nex4 = c
    ! Stores en(1000) as ex4(10000)
      do i=1,c
         ex4(i)=en(i)
      end do

c      print*, "There were ", c, "energies found"
      close (123)       ! Closes Data File
      return
      end





      subroutine go
      implicit none

      integer*4 z1,z2,z3,z4,a1,a2,a3,a4,n1,n2,n3,n4,i
      integer*4 neb,ieb,ntlab,itlab,nex3,iex3,nex4,iex4,nex2,iex2
      real*8    pi
      real*8    eb(10000),tlab(10000),ex3(10000),ex4(10000),ex2(10000)
      real*8    wtl,wtc,w1l,w2l,w3l,w4l,w1c,w2c,w3c,w4c
      real*8    p1l,p2l,p3l,p4l,p1c,p2c,p3c,p4c
      real*8    g2l,b2l,g3c,b3c,g4c,b4c,k3c,k4c,g,b
      real*8    e3l,e4l,t3l,t3c,t4l,t4c,jac3,jac4,aa,bb,cc,xa,xb,xc
      real*8    mn,mp,m1,m2,m3,m4,m30,m40,q0,m20
      real*8    amu,kp,brho,tmax,xx
      real*8 mass(300,200)
      common/blkst/eb,tlab,ex2,ex3,ex4,z1,z2,z3,z4,a1,a2,a3,a4,
     &       neb,ntlab,nex2,nex3,nex4
      common/ctol/t3l,t3c,k3c,k4c,w3c,w4c,b3c,b4c,m3,m4,g,b,pi
      common/masses/mass

      pi= dacos(-1.0d+00)
      mp=938.2792387
      mn=939.5725690
      amu=931.502

      n1=a1-z1
      n2=a2-z2
      n3=a3-z3
      n4=a4-z4
      m1=mass(a1,z1)*amu
      m20=mass(a2,z2)*amu
      m30=mass(a3,z3)*amu
      m40=mass(a4,z4)*amu
      q0=m1+m20-m30-m40

c      write(6,1)z1,a1,z2,a2,z3,a3,z4,a4
c      write(7,1)z1,a1,z2,a2,z3,a3,z4,a4
1     format(' {',i3,',',i3,'} ( {',i3,',',i3,'},{',i3,',',i3,'} ) {', 
     * i3,',',i3,'}')
c       write(7,7)
c       write(6,7)
7      format(' Ground state masses and Q0 value in MeV')
c      write(7,6)m1,m20,m30,m40,q0
c      write(6,6)m1,m20,m30,m40,q0
6     format('   M1        M2        M3        M4        Q0'/5f10.3)

      do 5000 iex2=1,nex2
      do 4000 ieb=1,neb
      do 3000 iex3=1,nex3
      do 2000 iex4=1,nex4

      m2=m20+ex2(iex2)
      m3=m30+ex3(iex3)
      m4=m40+ex4(iex4)

c      write(7,2)sngl(eb(ieb)),sngl(ex3(iex3)),sngl(ex4(iex4))
c     +,sngl(ex2(iex2))
c      write(6,2)sngl(eb(ieb)),sngl(ex3(iex3)),sngl(ex4(iex4))
c     +,sngl(ex2(iex2))
2     format(' Ebeam= ',f8.3,' MeV   Ex3= ',f8.3,' MeV   Ex4= ',
     *f8.3,' MeV   Ex2= ',f8.3)
c      write(7,4)
c      write(6,4)
4     format('    t3lab      t3cms     E3lab     t4lab     E4lab '
     *,'    jac3      k       QBrho')

      do 1000 itlab=1,ntlab

      w2l=eb(ieb)+m2
      g2l=w2l/m2
      b2l=dsqrt(1.0-1.0/(g2l*g2l))
      p2l=g2l*b2l*m2
      w1l=m1 
      wtl=w1l+w2l
      b=p2l/(w2l+m1)
      g=1.0/dsqrt(1.0-b*b)
      wtc=wtl/g 


      if(wtc.lt.m3+m4) then
         do i=iex4,nex4
            ex4(iex4)=ex4(iex4+1)
         end do
         nex4=nex4-1
         goto 1338
      end if

      if(wtc.gt.m3+m4) then  
        w3c=(wtc*wtc+m3*m3-m4*m4)/(2*wtc)
        p3c=dsqrt(w3c*w3c-m3*m3)
        g3c=w3c/m3
        b3c=dsqrt(1.0-1.0/(g3c*g3c))
        k3c=b/b3c
        w4c=(wtc*wtc+m4*m4-m3*m3)/(2*wtc)
        p4c=dsqrt(w4c*w4c-m4*m4)
        if (m4.eq.0.0d0) then 
          b4c=dsqrt(1.0d0)
        else
          g4c=w4c/m4
          b4c=dsqrt(1.0-1.0/(g4c*g4c))
        endif

        k4c=b/b4c
        t3l=tlab(itlab)
        xx=(m1-m4)*(m1+m4)+(m2-m3)*(2*m1+m2-m3)+2*eb(ieb)*(m1-m3) 
        aa=dcos(t3l)*dcos(t3l)+g*g*dsin(t3l)*dsin(t3l)
        bb=g*g*dsin(t3l)*dsin(t3l)*2.0*k3c
        cc=4.*dcos(t3l)*dcos(t3l)*(dcos(t3l)*dcos(t3l)+g*g*dsin(t3l)*
     *  dsin(t3l)*xx*(g3c/g+1.0)/((g3c*g3c-1.0)*(2.0*m3*wtl)))

c        print*, xx
cc        if((xx.eq.0.0).or.(xx.lt.0.0)) then
c            print*, "Win?"
c        end if

        if(xx.gt.0.0) then
c       Theta max does not exist
          if(dcos(t3l).ge.0.0) then
          t3c=dacos((-bb+dsqrt(cc))/(2.0*aa))
          elseif( dcos(t3l).lt.0.0 ) then
          t3c=dacos((-bb-dsqrt(cc))/(2.0*aa))
          endif

          call cmstolab

        elseif(xx.le.0.0) then
c       theta max does exist
          xa=-g*xx*(g3c+g)/(2.*m3*wtl*(g3c*g3c-1.0))
          tmax=dacos(dsqrt(xa/(xa+1.0)))
          if(t3l.gt.tmax) then
          write(7,11)tmax*180.0/pi
          write(6,11)tmax*180.0/pi
11        format(' The angle is out of range. The max angle is',f8.3)
          elseif(t3l.le.tmax)then
          t3c=dacos((-bb+dsqrt(cc))/(2.0*aa))

          call cmstolab

          if(xx.eq.0.0) goto 1001
          t3c=dacos((-bb-dsqrt(cc))/(2.0*aa))
          call cmstolab

1001      continue
          endif
        endif
      elseif (wtc.lt.m3+m4) then
        write(7,3)
        write(6,3)
3       format(' This reaction is q value forbidden')
      endif
1338  continue
1000  continue
2000  continue
3000  continue
4000  continue
5000  continue

c      dt = dt+nex4
      return
      end


      subroutine cmstolab
      implicit none
      real*8 t3l,t3c,k3c,k4c,w3c,w4c,b3c,b4c,m3,m4,g,b,pi
      real*8 t4c,t4l,w3l,e3l,w4l,e4l,jac3,kp,xa,xb,xc,qbrho
      real*8 dat(10000), ex4(10000)
      integer ct,dt, y(10000)
      common ct,dt,dat,y
      common/blkst/ex4
      common/ctol/t3l,t3c,k3c,k4c,w3c,w4c,b3c,b4c,m3,m4,g,b,pi
          t4c=-pi+t3c
          t4l=datan(dsin(t4c)/(g*(dcos(t4c)+k4c)))
          if ( t4c*t4l .lt. 0.0 ) then
            t4l=t4l-pi
          endif

          w3l=w3c*g*(1.0+b*b3c*dcos(t3c))
          e3l=w3l-m3
          w4l=w4c*g*(1.0+b*b4c*dcos(t4c))
          e4l=w4l-m4
          if(1.+k3c*dcos(t3c).gt.0.) then
          jac3=(dsin(t3c)*dsin(t3c)+g*g*(k3c+dcos(t3c))**2.0)**1.5
          jac3=jac3/(g*(1.+k3c*dcos(t3c)))
          elseif(1.+k3c*dcos(t3c).le.0.0) then
          jac3=(dsin(t3c)*dsin(t3c)+g*g*(k3c+dcos(t3c))**2.0)**1.5
          jac3=-jac3/(g*(1.+k3c*dcos(t3c)))
          endif

          kp=g*g*(dcos(t3c)+k3c)*(dcos(t3c)+k3c)+dsin(t3c)*dsin(t3c)
          kp=kp/(g*(1.0+k3c*dcos(t3c)))
          kp=-w3c*g*b*b3c*dsin(t3c)*kp
          kp=kp*w3l/(w3l*w3l-m3*m3)

          qbrho=3.3356*dsqrt(e3l*(2.*m3+e3l))

          xa=t3l*180.0/pi
          xb=t3c*180.0/pi
          xc=t4l*180.0/pi
          dt = dt+1
          dat(dt) = e3l
          y(dt) = ct
      return
      end


      SUBROUTINE decifr(IA,IZ,LN,REACTN)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C
C
C                 Subroutine DECIFR
C
C         This routine takes a reaction of the form :
C
C                      27AL(P,P)27AL
C
C    and returns the A and Z of the target, incident particle,
C    scattered particle and residual nucleus.
C
C         The reaction must be in upper case. Acceptable abbreviations
C    are :
C
C                      P = proton
C                      N = neutron
C                      D = deuteron
C                      T = triton
C                      A = alpha
C                      G = gamma
C                      E = electron
C
C         DECIFR calls AZ which does the actual determination of A and Z.
C
C    Major Variables :
C
C                      REACT,RCTIN - Character form of the input reaction.
C                      TRGT - Stores reaction target in character form.
C                      PROJ -   "        "    projectile   "        "
C                      SCAT -   "        "    scattered particle    "
C                      RES  -   "        "    residual nucleus      "
C
C           Written by C. Torre ................3/82
C         Modified by B.C. Karp ..............5/82
C
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!       implicit none

      CHARACTER REACT(25),TRGT(5),PROJ(5),SCAT(5),RES(5),
     &COMMA,BLANK,PRNTH1,PRNTH2
      INTEGER IA(20,4),IZ(20,4),LN,i,ierr,j,k,l,lin,lout,n,nproj,nres
     &,ntrgt,nscat
      PARAMETER (PRNTH1='(', PRNTH2=')', COMMA=',', BLANK=' ')
      CHARACTER*25 RCTIN,REACTN
      EQUIVALENCE(RCTIN,REACT)
      DATA LIN/5/,LOUT/6/

C       Prompt user for reaction.

c      WRITE(7,5)
c      write(6,5)
5     FORMAT (' Input reaction in form -  27Al(p,p)27Al  ',
     & /,' (Residual nucleus may be omitted.) ',$)
      write(*,*) "Input reaction in the form - 28Si(p,t):"
10      READ(LIN,15) RCTIN
15    FORMAT (A25)
      REACTN=RCTIN

C       Extract the target. NTRGT is the number of characters.

1       N=0
      DO 100 I=1,25
         N=N+1
         IF (REACT(I) .NE. PRNTH1) THEN
         IF(N.GT.5) GO TO 2000
            TRGT(N)=REACT(I)
         ELSE
            NTRGT=N-1

C        Extract the projectile.

            N=0
            DO 80 J=I+1,25
               N=N+1
               IF (REACT(J) .NE. COMMA) THEN
                IF(N.GT.5) GO TO 2000
                  PROJ(N)=REACT(J)
               ELSE
                  NPROJ=N-1

C        Extract the scattered particle.

                  N=0
                  DO 60 K=J+1,25
                     N=N+1
                     IF (REACT(K) .NE. PRNTH2) THEN
                    IF(N.GT.5) GO TO 2000
                        SCAT(N)=REACT(K)
                     ELSE
                        NSCAT=N-1

C        Extract the residual nucleus.

                        N=0
                        DO 40 L=K+1,25
                           N=N+1
                           IF (REACT(L) .NE. BLANK) THEN
                        IF(N.GT.5) GO TO 2000
                              RES(N)=REACT(L)
                           ELSE
                              NRES=N-1
                              GO TO 1000
                           END IF
40                        CONTINUE
                     END IF
60                  CONTINUE
               END IF
80            CONTINUE
         END IF
100     CONTINUE
1000    CONTINUE


C     Call AZ to convert the character data to A and Z.
      CALL AZ(TRGT,NTRGT,IA(LN,2),IZ(LN,2),IERR)
      IF(IERR.NE.0) GO TO 2000
      CALL AZ(PROJ,NPROJ,IA(LN,1),IZ(LN,1),IERR)
      IF(IERR.NE.0) GO TO 2000
      CALL AZ(SCAT,NSCAT,IA(LN,3),IZ(LN,3),IERR)
      IF(IERR.NE.0) GO TO 2000
      IF(NRES.GT.0) THEN
      CALL AZ(RES,NRES,IA(LN,4),IZ(LN,4),IERR)
      IF(IERR.NE.0) GO TO 2000
      ELSE
      IA(LN,4) = IA(LN,1) + IA(LN,2) - IA(LN,3)
      IZ(LN,4) = IZ(LN,1) + IZ(LN,2) - IZ(LN,3)
      ENDIF
      RETURN


C     ERROR HANDLING
2000  write(6,2001)
      WRITE(7,2001)
      GO TO 10

2001  FORMAT(' ERROR--Retype reaction code: ',$)
       END




      SUBROUTINE AZ(NAME,NCHAR,A,Z,IERR)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C                      Subroutine AZ
C
C
C     Subroutine to convert character representation of a nucleus or
C     particle into the appropriate A and Z.
C
C 
C       Major variables :
C
C                    NAME  -  Character representation of nucleus.
C                    EL    -  Character rep. of element
C                    ACHAR -     "       "   "     A.
C                    EL1   -  List of 1 character elements.
C                    EL2   -   "    " 2     "        "
C                    PRTCL -  List of particle abbreviations.
C                    ZEL1  -  Z corresponding to EL1.
C                    ZEL2  -  "       "       "  EL2.
C                    ZAP   -  A and Z for PRTCL.
C           ERROR CODES
C           0 - NO ERROR
C           1 - ELEMENT NOT FOUND
C           2 - Z > A
C
C            Notes :
C
C                AZ calls UPPER which converts character data to uppercase.
C
C                If no A is given via the calling program, the
C             routine assumes that a partical abbrev. is being
C             used
C
C                If the passed element is not identified, the routine
C             prints a message and assigns Z=0.
C
C                If Z > A the routine prints a message.
C
C
C       Written by.............C.Torre 3/82
C     Modified by............B.C. Karp 5/82
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      CHARACTER*2 EL,PRTCL(7),EL2(89),UPEL
      CHARACTER*3 ACHAR
      CHARACTER*5 NAME
      CHARACTER INTGR(10),EL1(14)
      INTEGER A,Z,ZEL1(14),ZEL2(89),ZAP(7,2)
      LOGICAL MATCH

C           Data initialization 

      DATA INTGR /'1','2','3','4','5','6','7','8','9','0'/
      DATA LIN/5/,LOUT/6/

C           Initialize values of character reps of elements and
C           values of Z's.

      DATA PRTCL /'P ','N ','D ','T ','A ','G ','E '/
      DATA ZAP /1,0,1,1,2,0,-1,1,1,2,3,4,0,-1/
      DATA EL1 /'H','B','C','N','O','F','P','S','K','V',
     &  'Y','I','W','U'/
      DATA EL2 /'HE','LI','BE','NE','NA','MG','AL','SI','CL'
     &  ,'AR','CA','SC','TI','CR','MN','FE','CO','NI','CU',
     &  'ZN','GA','GE','AS','SE','BR','KR','RB','SR','ZR',
     &  'NB','MO','TC','RU','RH','PD','AG','CD','IN','SN',
     &  'SB','TE','XE','CS','BA','LA','HF','PR','ND','PM',
     &  'SM','EU','GD','TB','DY','HO','ER','TM','YB','LU',
     &  'HF','TA','RF','OS','IR','PT','AU','HG','TL','PB',
     &  'BI','PO','AT','RN','FR','RA','AC','TH','PA','NP',
     &  'PU','AM','CM','BK','CF','ES','FM','MD','NO','LW'/

      DATA ZEL1 /1,5,6,7,8,9,15,16,19,23,39,53,74,92/
      DATA ZEL2 /2,3,4,10,11,12,13,14,17,18,20,21,22,24,25,26,
     &  27,28,29,30,31,32,33,34,35,36,37,38,40,41,42,43,44,45,
     &  46,47,48,49,50,51,52,54,55,56,57,58,59,60,61,62,63,64,
     &  65,66,67,68,69,70,71,72,73,75,76,77,78,79,80,81,82,83,
     &  84,85,86,87,88,89,90,91,93,94,95,96,97,98,99,100,101,
     &  102,103/

C       Extract A in character form.

      N=0
      IERR = 0
      DO 200 I=1,NCHAR
         N=N+1
         DO 180 J=1,10
            IF (NAME(I:I) .EQ. INTGR(J)) THEN
               GO TO 200
            END IF
180        CONTINUE
         GO TO 210
200     CONTINUE
210     NA=N-1
      NEL=NCHAR-NA
C
      ACHAR = NAME(:NA)

C       Extract element.
      EL = NAME(NA+1:NA+NEL)

C       Convert EL to upper case.
      CALL UPPER(EL,NEL,UPEL)

c     IF (NA .NE. 0 ) DECODE (NA,220,ACHAR) A
      IF (NA .NE. 0 ) READ(ACHAR,220)A
220         FORMAT (I3)
      MATCH=.FALSE.
3000    IF (NA .EQ. 0) THEN

C         If no A given, find element from list of abbreviations.
C         MATCH indicates the element has been identified.
         DO 2200 I=1,7
            IF (UPEL .EQ. PRTCL(I)) THEN
               MATCH=.TRUE.
               Z=ZAP(I,1)
               A=ZAP(I,2)
               GO TO 4000
            END IF
2200       CONTINUE
      END IF

C      Search EL1.
      IF (NEL .EQ. 1) THEN
         DO 2300 I=1,14
            IF (UPEL .EQ. EL1(I)) THEN
               MATCH=.TRUE.
               Z=ZEL1(I)
               GO TO 4000
            END IF
2300       CONTINUE
      ELSE

C         Search EL2
         DO 2400 I=1,89
            IF (UPEL .EQ. EL2(I)) THEN
               MATCH=.TRUE.
               Z=ZEL2(I)
               GO TO 4000
            END IF
2400       CONTINUE
      END IF
4000    CONTINUE


C       Error messages.
      IF (.NOT. MATCH) THEN
      write(6,4500) NAME
      WRITE(7,4500) NAME
      IERR = 1
      GO TO 5000
      ENDIF
4500        FORMAT (/,' Element ',A5,' not found.',/)

      IF (Z .GT. A) THEN
      write(6,4600) Z,A,NAME
      WRITE(7,4600) Z,A,NAME
      IERR = 2
      ENDIF
5000  CONTINUE
4600        FORMAT (/,' Z = ',I3,' is greater than  A = ',I3,
     &  /,' in element ',A5,'.')
      RETURN
      END


      SUBROUTINE UPPER(WORD,NCHAR,UPEL)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C                         Subroutine UPPER
C
C       Upper changes WORD into upper case and returns the upper case
C    version via UPEL.
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      CHARACTER*2 UPEL,WORD
      CHARACTER UP(26),DN(26)
      DATA UP/'A','B','C','D','E','F','G','H','I','J','K','L',
     &  'M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
      DATA DN/'a','b','c','d','e','f','g','h','i','j','k','l',
     &  'm','n','o','p','q','r','s','t','u','v','w','x','y','z'/
      UPEL=WORD
      DO 100 I=1,NCHAR
         DO 90 J=1,26
            IF (WORD(I:I) .EQ. DN(J)) THEN
               UPEL(I:I)=UP(J)
               GO TO 100
            END IF
90         CONTINUE
100     CONTINUE
      RETURN
      END


	subroutine loadmass
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C                                                                  C
C     This subroutine reads masses from wallet.dat and stores      C
C     them as the array 'mass'.                                    C
C                                                                  C
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      	implicit none
      	integer i,j,inum
      	integer iaf,izf
      	integer ia,iz,ierr,nchar,in(10000)
      	real*8 x,dm,amu,ms,mass(300,200)
      	character spc
      	character*2 sym
      	character*5 iso
      	character*10 char
      	common/masses/mass
      	spc=' '
      	amu=931.5
      	open(1,file='wallet.dat',status='old')
      	i=0
 5    	i=i+1
      	read(1,18,end=15)ia,sym,iz,x,char
           j=3
10         j=j+1
            if ((char(j:j).eq.spc).or.(j.eq.10)) goto 13
            goto 10
13         in(i)=j
           goto 5
15    	continue
      	inum=i-1
      	close(1)
17    	format(a10)
18    	format(i3,3x,a2,4x,i3,f6.3,2x,a10)
19    	format(2x,i2,2x,i2,2x,f12.6)
      	open(1,file='wallet.dat',status='old')
25    	do 50 i=1,inum
           goto (31,32,33,34,35,36,37,38,39,40),in(i)
31         continue
32         continue
33         continue
34         continue
           read(1,44,end=50)ia,sym,iz,x,dm
           goto 50
35         continue
           read(1,45,end=50)ia,sym,iz,x,dm
           mass(ia,iz)=ia+dm/amu
           goto 50
36         continue
           read(1,46,end=50)ia,sym,iz,x,dm
           mass(ia,iz)=ia+dm/amu
           goto 50
37         continue
           read(1,47,end=50)ia,sym,iz,x,dm
           mass(ia,iz)=ia+dm/amu
           goto 50
38         continue
           read(1,48,end=50)ia,sym,iz,x,dm
           mass(ia,iz)=ia+dm/amu
           goto 50
39         continue
           read(1,49,end=50)ia,sym,iz,x,dm
           mass(ia,iz)=ia+dm/amu
           goto 50
40         continue
           read(1,49,end=50)ia,sym,iz,x,dm
           mass(ia,iz)=ia+dm/amu
           goto 50
44         format(i3,3x,a2,4x,i3,f6.3,2x,f4.1)
45         format(i3,3x,a2,4x,i3,f6.3,2x,f5.2)
46         format(i3,3x,a2,4x,i3,f6.3,2x,f6.3)
47         format(i3,3x,a2,4x,i3,f6.3,2x,f7.4)
48         format(i3,3x,a2,4x,i3,f6.3,2x,f8.5)
49         format(i3,3x,a2,4x,i3,f6.3,2x,f9.6)
50         continue
      	close(1)
	return
80      end



      subroutine initdat

      Write(7,*) '      # Grace project file    '
      Write(7,*) '      #     '
      Write(7,*) '      @version 50122    '
      Write(7,*) '      @page size 792, 612     '
      Write(7,*) '      @page scroll 5%   '
      Write(7,*) '      @page inout 5%    '
      Write(7,*) '      @link page off    '
      Write(7,*) '      @map font 8 to "Courier", "Courier" '
      Write(7,*) '      @map font 10 to "Courier-Bold", "Courier-Bold"'
      Write(7,*) '      @map font 11 to "Courier-BoldOblique", "Courier
     &-BoldOblique"'
      Write(7,*) '      @map font 9 to "Courier-Oblique", "Courier-Obli
     &que"'
      Write(7,*) '      @map font 4 to "Helvetica", "Helvetica"   '
      Write(7,*) '      @map font 6 to "Helvetica-Bold", "Helvetica-Bol
     &d"'
      Write(7,*) '      @map font 7 to "Helvetica-BoldOblique", "Helvet
     &ica-BoldOblique"   '
      Write(7,*) '      @map font 15 to "Helvetica-Narrow", "Helvetica-
     &Narrow"      '
      Write(7,*) '      @map font 16 to "Helvetica-Narrow-Bold", "Helvetica-
     &Narrow-Bold"  '
      Write(7,*) '      @map font 17 to "Helvetica-Narrow-BoldOblique", 
     &"Helvetica-Narrow-BoldOblique"      '
      Write(7,*) '      @map font 18 to "Helvetica-Narrow-Oblique", 
     &"Helvetica-Narrow-Oblique"  '
      Write(7,*) '      @map font 5 to "Helvetica-Oblique", "Helvetica-
     &Oblique"     '
      Write(7,*) '      @map font 20 to "NewCenturySchlbk-Bold", "New
     &CenturySchlbk-Bold"  '
      Write(7,*) '      @map font 21 to "NewCenturySchlbk-BoldItalic", 
     &"NewCenturySchlbk-BoldItalic"  '
      Write(7,*) '      @map font 22 to "NewCenturySchlbk-Italic", 
     &"NewCenturySchlbk-Italic"    '
      Write(7,*) '      @map font 23 to "NewCenturySchlbk-Roman", "New
     &CenturySchlbk-Roman"      '
      Write(7,*) '      @map font 24 to "Palatino-Bold", "Palatino-Bol
     &d"'
      Write(7,*) '      @map font 25 to "Palatino-BoldItalic", "Palati
     &no-BoldItalic"      '
      Write(7,*) '      @map font 26 to "Palatino-Italic", "Palatino-
     &Italic"  '
      Write(7,*) '      @map font 27 to "Palatino-Roman", "Palatino-Ro
     &man"'
      Write(7,*) '      @map font 12 to "Symbol", "Symbol"  '
      Write(7,*) '      @map font 2 to "Times-Bold", "Times-Bold" '
      Write(7,*) '      @map font 3 to "Times-BoldItalic", "Times-Bold
     &Italic" '
      Write(7,*) '      @map font 1 to "Times-Italic", "Times-Italic"'
      Write(7,*) '      @map font 0 to "Times-Roman", "Times-Roman"'
      Write(7,*) '      @map font 33 to "ZapfChancery-MediumItalic", 
     &"ZapfChancery-MediumItalic"      '
      Write(7,*) '      @map font 13 to "ZapfDingbats", "ZapfDing
     &bats"'
      Write(7,*) '      @map color 0 to (255, 255, 255), "white"  '
      Write(7,*) '      @map color 1 to (0, 0, 0), "black"  '
      Write(7,*) '      @map color 2 to (255, 0, 0), "red"  '
      Write(7,*) '      @map color 3 to (0, 255, 0), "green"      '
      Write(7,*) '      @map color 4 to (0, 0, 255), "blue" '
      Write(7,*) '      @map color 5 to (255, 255, 0), "yellow"   '
      Write(7,*) '      @map color 6 to (188, 143, 143), "brown"  '
      Write(7,*) '      @map color 7 to (220, 220, 220), "grey"   '
      Write(7,*) '      @map color 8 to (148, 0, 211), "violet"   '
      Write(7,*) '      @map color 9 to (0, 255, 255), "cyan"     '
      Write(7,*) '      @map color 10 to (255, 0, 255), "magenta" '
      Write(7,*) '      @map color 11 to (255, 165, 0), "orange"  '
      Write(7,*) '      @map color 12 to (114, 33, 188), "indigo" '
      Write(7,*) '      @map color 13 to (103, 7, 72), "maroon"   '
      Write(7,*) '      @map color 14 to (64, 224, 208), "turquoise"'
      Write(7,*) '      @map color 15 to (0, 139, 0), "green4"    '
      Write(7,*) '      @reference date 0 '
      Write(7,*) '      @date wrap off    '
      Write(7,*) '      @date wrap year 1950    '
      Write(7,*) '      @default linewidth 1.0  '
      Write(7,*) '      @default linestyle 1    '
      Write(7,*) '      @default color 1  '
      Write(7,*) '      @default pattern 1      '
      Write(7,*) '      @default font 0   '
      Write(7,*) '      @default char size 1.000000   '
      Write(7,*) '      @default symbol size 1.000000 '
      Write(7,*) '      @default sformat "%.8g" '
      Write(7,*) '      @background color 0     '
      Write(7,*) '      @page background fill on      '
      Write(7,*) '      @timestamp off    '
      Write(7,*) '      @timestamp 0.03, 0.03   '
      Write(7,*) '      @timestamp color 1      '
      Write(7,*) '      @timestamp rot 0  '
      Write(7,*) '      @timestamp font 0 '
      Write(7,*) '      @timestamp char size 1.000000 '
      Write(7,*) '      @timestamp def "Thu Jul 15 14:16:34 2010" '
      Write(7,*) '      @r0 off     '
      Write(7,*) '      @link r0 to g0    '
      Write(7,*) '      @r0 type above    '
      Write(7,*) '      @r0 linestyle 1   '
      Write(7,*) '      @r0 linewidth 1.0 '
      Write(7,*) '      @r0 color 1 '
      Write(7,*) '      @r0 line 0, 0, 0, 0     '
      Write(7,*) '      @r1 off     '
      Write(7,*) '      @link r1 to g0    '
      Write(7,*) '      @r1 type above    '
      Write(7,*) '      @r1 linestyle 1   '
      Write(7,*) '      @r1 linewidth 1.0 '
      Write(7,*) '      @r1 color 1 '
      Write(7,*) '      @r1 line 0, 0, 0, 0     '
      Write(7,*) '      @r2 off     '
      Write(7,*) '      @link r2 to g0    '
      Write(7,*) '      @r2 type above    '
      Write(7,*) '      @r2 linestyle 1   '
      Write(7,*) '      @r2 linewidth 1.0 '
      Write(7,*) '      @r2 color 1 '
      Write(7,*) '      @r2 line 0, 0, 0, 0     '
      Write(7,*) '      @r3 off     '
      Write(7,*) '      @link r3 to g0    '
      Write(7,*) '      @r3 type above    '
      Write(7,*) '      @r3 linestyle 1   '
      Write(7,*) '      @r3 linewidth 1.0 '
      Write(7,*) '      @r3 color 1 '
      Write(7,*) '      @r3 line 0, 0, 0, 0     '
      Write(7,*) '      @r4 off     '
      Write(7,*) '      @link r4 to g0    '
      Write(7,*) '      @r4 type above    '
      Write(7,*) '      @r4 linestyle 1   '
      Write(7,*) '      @r4 linewidth 1.0 '
      Write(7,*) '      @r4 color 1 '
      Write(7,*) '      @r4 line 0, 0, 0, 0     '
      Write(7,*) '      @g0 on      '
      Write(7,*) '      @g0 hidden false  '
      Write(7,*) '      @g0 type XY '
      Write(7,*) '      @g0 stacked false '
      Write(7,*) '      @g0 bar hgap 0.000000   '
      Write(7,*) '      @g0 fixedpoint off      '
      Write(7,*) '      @g0 fixedpoint type 0   '
      Write(7,*) '      @g0 fixedpoint xy 0.000000, 0.000000      '
      Write(7,*) '      @g0 fixedpoint format general general     '
      Write(7,*) '      @g0 fixedpoint prec 6, 6      '
      Write(7,*) '      @with g0    '
      Write(7,*) '      @    world 4, 0, 20, 4  '
      Write(7,*) '      @    stack world 0, 0, 0, 0   '
      Write(7,*) '      @    znorm 1      '
      Write(7,*) '      @    view 0.150000, 0.150000, 1.150000, 
     &0.850000'
      Write(7,*) '      @    title ""     '
      Write(7,*) '      @    title font 0 '
      Write(7,*) '      @    title size 1.500000      '
      Write(7,*) '      @    title color 1      '
      Write(7,*) '      @    subtitle ""  '
      Write(7,*) '      @    subtitle font 0    '
      Write(7,*) '      @    subtitle size 1.000000   '
      Write(7,*) '      @    subtitle color 1   '
      Write(7,*) '      @    xaxes scale Normal '
      Write(7,*) '      @    yaxes scale Normal '
      Write(7,*) '      @    xaxes invert off   '
      Write(7,*) '      @    yaxes invert off   '
      Write(7,*) '      @    xaxis  on    '
      Write(7,*) '      @    xaxis  type zero false   '
      Write(7,*) '      @    xaxis  offset 0.000000 , 0.000000    '
      Write(7,*) '      @    xaxis  bar on      '
      Write(7,*) '      @    xaxis  bar color 1 '
      Write(7,*) '      @    xaxis  bar linestyle 1   '
      Write(7,*) '      @    xaxis  bar linewidth 1.0 '
      Write(7,*) '      @    xaxis  label ""    '
      Write(7,*) '      @    xaxis  label layout para '
      Write(7,*) '      @    xaxis  label place auto  '
      Write(7,*) '      @    xaxis  label char size 1.000000      '
      Write(7,*) '      @    xaxis  label font 0      '
      Write(7,*) '      @    xaxis  label color 1     '
      Write(7,*) '      @    xaxis  label place normal      '
      Write(7,*) '      @    xaxis  tick on     '
      Write(7,*) '      @    xaxis  tick major 1      '
      Write(7,*) '      @    xaxis  tick minor ticks 1      '
      Write(7,*) '      @    xaxis  tick default 6    '
      Write(7,*) '      @    xaxis  tick place rounded true '
      Write(7,*) '      @    xaxis  tick in     '
      Write(7,*) '      @    xaxis  tick major size 1.000000      '
      Write(7,*) '      @    xaxis  tick major color 1      '
      Write(7,*) '      @    xaxis  tick major linewidth 1.0      '
      Write(7,*) '      @    xaxis  tick major linestyle 1  '
      Write(7,*) '      @    xaxis  tick major grid off     '
      Write(7,*) '      @    xaxis  tick minor color 1      '
      Write(7,*) '      @    xaxis  tick minor linewidth 1.0      '
      Write(7,*) '      @    xaxis  tick minor linestyle 1  '
      Write(7,*) '      @    xaxis  tick minor grid off     '
      Write(7,*) '      @    xaxis  tick minor size 0.000000      '
      Write(7,*) '      @    xaxis  ticklabel on      '
      Write(7,*) '      @    xaxis  ticklabel format general      '
      Write(7,*) '      @    xaxis  ticklabel prec 5  '
      Write(7,*) '      @    xaxis  ticklabel formula ""    '
      Write(7,*) '      @    xaxis  ticklabel append ""     '
      Write(7,*) '      @    xaxis  ticklabel prepend ""    '
      Write(7,*) '      @    xaxis  ticklabel angle 0 '
      Write(7,*) '      @    xaxis  ticklabel skip 0  '
      Write(7,*) '      @    xaxis  ticklabel stagger 0     '
      Write(7,*) '      @    xaxis  ticklabel place normal  '
      Write(7,*) '      @    xaxis  ticklabel offset auto   '
      Write(7,*) '      @    xaxis  ticklabel offset 0.000000 , 
     &0.010000'
      Write(7,*) '      @    xaxis  ticklabel start type auto     '
      Write(7,*) '      @    xaxis  ticklabel start 0.000000      '
      Write(7,*) '      @    xaxis  ticklabel stop type auto      '
      Write(7,*) '      @    xaxis  ticklabel stop 0.000000 '
      Write(7,*) '      @    xaxis  ticklabel char size 1.000000  '
      Write(7,*) '      @    xaxis  ticklabel font 0  '
      Write(7,*) '      @    xaxis  ticklabel color 1 '
      Write(7,*) '      @    xaxis  tick place both   '
      Write(7,*) '      @    xaxis  tick spec type none     '
      Write(7,*) '      @    yaxis  on    '
      Write(7,*) '      @    yaxis  type zero false   '
      Write(7,*) '      @    yaxis  offset 0.000000 , 0.000000    '
      Write(7,*) '      @    yaxis  bar on      '
      Write(7,*) '      @    yaxis  bar color 1 '
      Write(7,*) '      @    yaxis  bar linestyle 1   '
      Write(7,*) '      @    yaxis  bar linewidth 1.0 '
      Write(7,*) '      @    yaxis  label ""    '
      Write(7,*) '      @    yaxis  label layout para '
      Write(7,*) '      @    yaxis  label place auto  '
      Write(7,*) '      @    yaxis  label char size 1.000000      '
      Write(7,*) '      @    yaxis  label font 0      '
      Write(7,*) '      @    yaxis  label color 1     '
      Write(7,*) '      @    yaxis  label place normal      '
      Write(7,*) '      @    yaxis  tick on     '
      Write(7,*) '      @    yaxis  tick major 0.2    '
      Write(7,*) '      @    yaxis  tick minor ticks 1      '
      Write(7,*) '      @    yaxis  tick default 6    '
      Write(7,*) '      @    yaxis  tick place rounded true '
      Write(7,*) '      @    yaxis  tick in     '
      Write(7,*) '      @    yaxis  tick major size 0.000000      '
      Write(7,*) '      @    yaxis  tick major color 1      '
      Write(7,*) '      @    yaxis  tick major linewidth 1.0      '
      Write(7,*) '      @    yaxis  tick major linestyle 1  '
      Write(7,*) '      @    yaxis  tick major grid off     '
      Write(7,*) '      @    yaxis  tick minor color 1      '
      Write(7,*) '      @    yaxis  tick minor linewidth 1.0      '
      Write(7,*) '      @    yaxis  tick minor linestyle 1  '
      Write(7,*) '      @    yaxis  tick minor grid off     '
      Write(7,*) '      @    yaxis  tick minor size 0.000000      '
      Write(7,*) '      @    yaxis  ticklabel on      '
      Write(7,*) '      @    yaxis  ticklabel format general      '
      Write(7,*) '      @    yaxis  ticklabel prec 5  '
      Write(7,*) '      @    yaxis  ticklabel formula ""    '
      Write(7,*) '      @    yaxis  ticklabel append ""     '
      Write(7,*) '      @    yaxis  ticklabel prepend ""    '
      Write(7,*) '      @    yaxis  ticklabel angle 0 '
      Write(7,*) '      @    yaxis  ticklabel skip 0  '
      Write(7,*) '      @    yaxis  ticklabel stagger 0     '
      Write(7,*) '      @    yaxis  ticklabel place normal  '
      Write(7,*) '      @    yaxis  ticklabel offset auto   '
      Write(7,*) '      @    yaxis  ticklabel offset 0.000000 , 
     &0.010000'
      Write(7,*) '      @    yaxis  ticklabel start type auto     '
      Write(7,*) '      @    yaxis  ticklabel start 0.000000      '
      Write(7,*) '      @    yaxis  ticklabel stop type auto      '
      Write(7,*) '      @    yaxis  ticklabel stop 0.000000 '
      Write(7,*) '      @    yaxis  ticklabel char size 0.000000  '
      Write(7,*) '      @    yaxis  ticklabel font 0  '
      Write(7,*) '      @    yaxis  ticklabel color 1 '
      Write(7,*) '      @    yaxis  tick place both   '
      Write(7,*) '      @    yaxis  tick spec type none     '
      Write(7,*) '      @    altxaxis  off      '
      Write(7,*) '      @    altyaxis  off      '
      Write(7,*) '      @    legend on    '
      Write(7,*) '      @    legend loctype view      '
      Write(7,*) '      @    legend 0.85, 0.8   '
      Write(7,*) '      @    legend box color 1 '
      Write(7,*) '      @    legend box pattern 1     '
      Write(7,*) '      @    legend box linewidth 1.0 '
      Write(7,*) '      @    legend box linestyle 1   '
      Write(7,*) '      @    legend box fill color 0  '
      Write(7,*) '      @    legend box fill pattern 1      '
      Write(7,*) '      @    legend font 0      '
      Write(7,*) '      @    legend char size 1.000000      '
      Write(7,*) '      @    legend color 1     '
      Write(7,*) '      @    legend length 4    '
      Write(7,*) '      @    legend vgap 1      '
      Write(7,*) '      @    legend hgap 1      '
      Write(7,*) '      @    legend invert false      '
      Write(7,*) '      @    frame type 0 '
      Write(7,*) '      @    frame linestyle 1  '
      Write(7,*) '      @    frame linewidth 1.0      '
      Write(7,*) '      @    frame color 1      '
      Write(7,*) '      @    frame pattern 1    '
      Write(7,*) '      @    frame background color 0 '
      Write(7,*) '      @    frame background pattern 0     '
      Write(7,*) '      @    s0 hidden false    '
      Write(7,*) '      @    s0 type xydydy     '
      Write(7,*) '      @    s0 symbol 0  '
      Write(7,*) '      @    s0 symbol size 1.000000  '
      Write(7,*) '      @    s0 symbol color 1  '
      Write(7,*) '      @    s0 symbol pattern 1      '
      Write(7,*) '      @    s0 symbol fill color 1   '
      Write(7,*) '      @    s0 symbol fill pattern 0 '
      Write(7,*) '      @    s0 symbol linewidth 1.0  '
      Write(7,*) '      @    s0 symbol linestyle 1    '
      Write(7,*) '      @    s0 symbol char 65  '
      Write(7,*) '      @    s0 symbol char font 0    '
      Write(7,*) '      @    s0 symbol skip 0   '
      Write(7,*) '      @    s0 line type 0     '
      Write(7,*) '      @    s0 line linestyle 1      '
      Write(7,*) '      @    s0 line linewidth 1.0    '
      Write(7,*) '      @    s0 line color 1    '
      Write(7,*) '      @    s0 line pattern 1  '
      Write(7,*) '      @    s0 baseline type 0 '
      Write(7,*) '      @    s0 baseline off    '
      Write(7,*) '      @    s0 dropline off    '
      Write(7,*) '      @    s0 fill type 0     '
      Write(7,*) '      @    s0 fill rule 0     '
      Write(7,*) '      @    s0 fill color 1    '
      Write(7,*) '      @    s0 fill pattern 1  '
      Write(7,*) '      @    s0 avalue off      '
      Write(7,*) '      @    s0 avalue type 2   '
      Write(7,*) '      @    s0 avalue char size 1.000000   '
      Write(7,*) '      @    s0 avalue font 0   '
      Write(7,*) '      @    s0 avalue color 1  '
      Write(7,*) '      @    s0 avalue rot 0    '
      Write(7,*) '      @    s0 avalue format general '
      Write(7,*) '      @    s0 avalue prec 3   '
      Write(7,*) '      @    s0 avalue prepend ""     '
      Write(7,*) '      @    s0 avalue append ""      '
      Write(7,*) '      @    s0 avalue offset 0.000000 , 0.000000 '
      Write(7,*) '      @    s0 errorbar on     '
      Write(7,*) '      @    s0 errorbar place both   '
      Write(7,*) '      @    s0 errorbar color 1      '
      Write(7,*) '      @    s0 errorbar pattern 1    '
      Write(7,*) '      @    s0 errorbar size 10.000000     '
      Write(7,*) '      @    s0 errorbar linewidth 1.0      '
      Write(7,*) '      @    s0 errorbar linestyle 1  '
      Write(7,*) '      @    s0 errorbar riser linewidth 1.0      '
      Write(7,*) '      @    s0 errorbar riser linestyle 1  '
      Write(7,*) '      @    s0 errorbar riser clip off     '
      Write(7,*) '      @    s0 errorbar riser clip length 0.100000'
      Write(7,*) '      @    s0 comment "relkin.log"  '
      Write(7,*) '      @    s0 legend  ""      '
      Write(7,*) '      @target G0.S0     '
      Write(7,*) '      @type xydydy      '
      Write(7,*) '      @with line  '
      Write(7,*) '      @    line on      '
      Write(7,*) '      @    line loctype view  '
      Write(7,*) '      @    line 1.14950980392, 0.675245098039, 
     &0.149509803922, 0.675245098039 '
      Write(7,*) '      @    line linewidth 1.0 '
      Write(7,*) '      @    line linestyle 1   '
      Write(7,*) '      @    line color 1 '
      Write(7,*) '      @    line arrow 0 '
      Write(7,*) '      @    line arrow type 0  '
      Write(7,*) '      @    line arrow length 1.000000     '
      Write(7,*) '      @    line arrow layout 1.000000, 
     &1.000000 '
      Write(7,*) '      @line def   '
      Write(7,*) '      @with line  '
      Write(7,*) '      @    line on      '
      Write(7,*) '      @    line loctype view  '
      Write(7,*) '      @    line 1.14950980392, 0.5, 
     &0.149509803922, 0.5     '
      Write(7,*) '      @    line linewidth 1.0 '
      Write(7,*) '      @    line linestyle 1   '
      Write(7,*) '      @    line color 1 '
      Write(7,*) '      @    line arrow 0 '
      Write(7,*) '      @    line arrow type 0  '
      Write(7,*) '      @    line arrow length 1.000000     '
      Write(7,*) '      @    line arrow layout 1.000000, 1.000000 '
      Write(7,*) '      @line def   '
      Write(7,*) '      @with line  '
      Write(7,*) '      @    line on      '
      Write(7,*) '      @    line loctype view  '
      Write(7,*) '      @    line 1.14950980392, 0.324754901961, 
     &0.149509803922, 0.324754901961 '
      Write(7,*) '      @    line linewidth 1.0 '
      Write(7,*) '      @    line linestyle 1   '
      Write(7,*) '      @    line color 1 '
      Write(7,*) '      @    line arrow 0 '
      Write(7,*) '      @    line arrow type 0  '
      Write(7,*) '      @    line arrow length 1.000000     '
      Write(7,*) '      @    line arrow layout 1.000000, 1.000000 '
      Write(7,*) '      @line def   '
      Write(7,*) '      @with string'
      Write(7,*) '      @    string on'
      Write(7,*) '      @    string loctype view'
      Write(7,*) '      @    string 0.446078431373, 0.080882352941'
      Write(7,*) '      @    string color 1'
      Write(7,*) '      @    string rot 0'
      Write(7,*) '      @    string font 0'
      Write(7,*) '      @    string just 0'
      Write(7,*) '      @    string char size 1.000000'
      Write(7,*) '      @    string def 
     &"Energy of Scattered Particle (MeV)"'


      end

      subroutine lbl(reactn,num,en,ang)
      character*25 reactn
      integer num
      real*8 en, ang, ang2
      ang2 = ang
      ang2 = (ang2/(2*3.1415926535))*360

      if(num.eq.1) then
         write(7,*) '@with string'
         write(7,*) '@    string on'
         write(7,*) '@    string loctype view'
         write(7,*) '@    string 0.014705882353, 0.219362745098'
         write(7,*) '@    string color 1'
         write(7,*) '@    string rot 0'
         write(7,*) '@    string font 0'
         write(7,*) '@    string just 0'
         write(7,*) '@    string char size 0.730000'
         write(7,1) '@    string def "',reactn, '"'
1        format(A20,A15,A1)
         write(7,*) '@with string'
         write(7,*) '@    string on'
         write(7,*) '@    string loctype view'
         write(7,*) '@    string 0.234068627451, 0.882352941176'
         write(7,*) '@    string color 1'
         write(7,*) '@    string rot 0'
         write(7,*) '@    string font 0'
         write(7,*) '@    string just 0'
         write(7,*) '@    string char size 1.000000'
         write(7,10) '@    string def "Energy Distribution at ', ang2,
     &              ' Degrees with ', en, ' MeV Incident Beam"'
10       format(A40,F5.1,A14,F5.1,A20)
      end if

      if(num.eq.2) then
         write(7,*) '@with string'
         write(7,*) '@    string on'
         write(7,*) '@    string loctype view'
         write(7,*) '@    string 0.014705882353, 0.425245098039'
         write(7,*) '@    string color 1'
         write(7,*) '@    string rot 0'
         write(7,*) '@    string font 0'
         write(7,*) '@    string just 0'
         write(7,*) '@    string char size 0.730000'
         write(7,2) '@    string def "',reactn, '"'
2        format(A20,A15,A1)
      end if

      if(num.eq.3) then
         write(7,*) '@with string'
         write(7,*) '@    string on'
         write(7,*) '@    string loctype view'
         write(7,*) '@    string 0.014705882353, 0.594362745098'
         write(7,*) '@    string color 1'
         write(7,*) '@    string rot 0'
         write(7,*) '@    string font 0'
         write(7,*) '@    string just 0'
         write(7,*) '@    string char size 0.730000'
         write(7,3) '@    string def "',reactn, '"'
3        format(A20,A15,A1)
      end if

      if(num.eq.4) then
         write(7,*) '@with string'
         write(7,*) '@    string on'
         write(7,*) '@    string loctype view'
         write(7,*) '@    string 0.014705882353, 0.769607843137'
         write(7,*) '@    string color 1'
         write(7,*) '@    string rot 0'
         write(7,*) '@    string font 0'
         write(7,*) '@    string just 0'
         write(7,*) '@    string char size 0.730000'
         write(7,4) '@    string def "',reactn, '"'
4        format(A20,A15,A1)
      end if
      end


      subroutine datalbl(x,y,en)
      implicit none
      real*8 x,en
      integer y

      write(7,*) '@with string'
      write(7,*) '@    string on'
      write(7,*) '@    string loctype world'
      write(7,6) '@    string ', x, ", ", y
6     format(A12, f10.4, A1, I1)
      write(7,*) '@    string color 1'
      write(7,*) '@    string rot 90'
      write(7,*) '@    string font 0'
      write(7,*) '@    string just 0'
      write(7,*) '@    string char size 0.600000'
      write(7,7) '@    string def "', en, '"'
7     format(A20,f5.2,A1)
      end

